#ifndef LOADIMAGE_H
#define LOADIMAGE_H

#include <iostream>
#include <vector>
#include "Dal.h"
#include "WCSinfo.h"

class loadImage {


public:
	loadImage(std::string imagefile, std::string regcoordtype, std::string shape_bkg_1strow, std::vector<double> src_and_bkg_regions, int backscale, double total_spec_counts);
	//loadImage(std::string imagefile, bool withZClip);
	std::vector<int> getImageSize();
	std::vector<double> getImageeffMinMax();
	float * getImage();
	std::vector<int> getXY_limits();

	CoordPair getRefPixels();
	CoordPair getRefCoords();
	CoordPair getPixelSizeWorld();
	std::string getxType();
	std::string getyType();
	//const char * getxType();
	//const char * getyType();
	std::string getXUnit();
	std::string getYUnit();
	real64 getrotAngle();
	std::vector<real64> getMatrixOnOffAxis();
	std::string getobs_id();
	std::string getInstr();
	std::string getDatamode();
	std::string getSubmode();
	std::string getExpid();
	std::string getFilter();
	std::string getObject();
	std::string getObserver();
	std::string getDate();
	double getExp();

	std::vector<double> getPixVec();


private:
	void calImage();
	//void maskArrayLimits();
	std::string _imagefile;
	std::string _regcoordtype;
	std::vector<int> _resSize;
	std::vector<double> _res_effMinMax;
	float * _image;
	//bool _withZClip;
	std::string _shape_bkg_1strow;
	std::vector<double> _src_and_bkg_regions;
	int _backscale;
	//double _world_test[2];

	CoordPair _PixelSizeWorld;
	CoordPair _refPixels;
	CoordPair _refCoords;
	std::string  _ctype1;
	std::string  _ctype2;
	//const char * _ctype1;
	//const char * _ctype2;
	std::string _XworldUnit;
	std::string _YworldUnit;
	real64 _rotAngle;
	std::vector<real64> _MatrixOnOffAxis;
	int _minx, _maxx, _miny, _maxy;
	std::vector<int> _XY_limits;
	std::string  _obs_id;
	std::string  _instr;
	std::string  _datamode;
	std::string  _submode;
	std::string  _expid;
	std::string  _filter;
	std::string  _object;
	std::string  _observer;
	std::string  _date_obs;
	double  _exposure;
	double _total_spec_counts;
	std::vector<double> _pixVec;
	//int _nx;
	//int _ny;
	//float _test_image [648][648];

	//void calReg_full();
	//void calRegMOS_small();
	//std::vector<int> calCCDlimits();
	//double _rawx;
	//double _rawy;
	//int _ccdnr;
	//double _rad;
	//std::vector<int> ccd_limits;
	//std::string _instr;
	//std::string _mode;
	//

};

#endif
