#ifndef PLOTIMAGE_H
#define PLOTIMAGE_H

#include <iostream>
#include <vector>
#include "Dal.h"
#include "Task.h"

class plotImage {

public:
	plotImage(float* image, std::vector<double> effMinMax, std::vector<int> size, std::vector<int> xy_limits, std::string imagefile, std::string instr, std::string datamode, std::string submode, std::string filter, std::string object, std::string observer, std::string date_obs, double exposure, std::string spec_file);
	//std::vector<double> getPlot();

private:
	void calPlot();
	void set_palette();
	void plotRHinfo();
	float* TransformMatrix();
	float* _image;
	std::vector<double> _effMinMax;
	std::vector<int> _size;
	std::vector<int> _xy_limits;
	float _rhCharX;
	float _rhCharDy;
	float _rhCharXindent;
	float _rhCharYindent;
	float _rhCharSize;
	std::string _imagefile;
	std::string _instr;
	std::string _datamode;
	std::string _submode;
	std::string _filter;
	std::string _object;
	std::string _observer;
	std::string _date_obs;
	std::string _imageTransferStyle;
	double _exposure;
	std::string _spec_file;
	int _minx;
	int _maxx;
	int _miny;
	int _maxy;
	//void calRegMOS_small();
	//std::vector<int> calCCDlimits();
	//double _rawx;
	//double _rawy;
	//int _ccdnr;
	//double _rad;
	//std::vector<int> ccd_limits;
	//std::string _device;
	//std::string _instr;
	//std::string _mode;
	//std::vector<double> _res;

};

#endif
